<template>
    <div class="order-request-execution">
      <ObForm
        :form-model="formModel"
        :form-data="formData"
        ok-text="Отменить заказ"
        cancel-text="Не отменять"
        :is-loading="isLoading"
        :is-error="true"
        data-qa="ChangePvpForm"
        @submit="onSubmitHandler"
      >
        <p>Заказ клиента и все связанные с ним рейсы будут отменены.</p>
<!--        <div class="title">Кем инициирована отмена заказа</div>-->
<!--        <ObRadio-->
<!--          v-model="formData.cancelInitiator"-->
<!--          label="Экспедитором"-->
<!--          :valueInput="'EXPEDITOR'"-->
<!--          class="mb10"-->
<!--          data-qa="isExpeditor"-->
<!--        />-->
<!--        <ObRadio-->
<!--          v-model="formData.cancelInitiator"-->
<!--          label="Заказчиком"-->
<!--          :valueInput="'CLIENT'"-->
<!--          class="mb10"-->
<!--          data-qa="isClient"-->
<!--        />-->
        <ObTextarea
          v-model="formData.comment"
          label="Заметки"
          placeholder="Введите комментарий"
        />
        <div class="title">Бумажные документы, связанные с событием</div>
        <ObUploader
          ref="uploader"
          data-qa="uploader"
          :upload-method="uploadMethod"
          @process-start="startUploadFiles"
          @change="onUploadHandler"
        />
      </ObForm>
      <ObModal
        ref="confirmModal"
        title="Отмена заказа Клиента"
        ok-text="Подтвердить"
        :is-error="true"
        :is-show-controls="true"
        :is-submit-disabled="isSubmitDisabled"
        @submit="cancelOrder(formData)"
      >
        <p>Заказ клиента и все связанные с ним рейсы будут отменены. Вы уверены, что хотите отменить заказ?</p>
      </ObModal>
    </div>
</template>

<script>
import ObModal from 'common-components/src/obComponents/obModal'
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
// import ObRadio from 'common-components/src/obComponents/obRadio'
import ObUploader from 'common-components/src/obComponents/obUploader'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import { required } from 'vuelidate/lib/validators'

export default {
  name: 'CancelOrderModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObTextarea,
    // ObRadio,
    ObUploader,
    ObModal
  },
  props: {
    order: {
      type: Object,
      required: true
    }
  },
  data () {
    return {
      isLoading: false
    }
  },
  computed: {
    formModel () {
      return {
        orderUuid: {
          value: () => this.order.uuid
        },
        fileUuids: {
          value: '',
          validator: {
            required
          }
        },
        comment: {
          value: ''
        }
      }
    },
    uploadMethod () {
      return api.files.postFile
    },
    isSubmitDisabled () {
      return !this.order.isEditable ? true : undefined
    }
  },
  watch: {
    'formData.fileUuids' (value) {
      if (!value) {
        this.$refs.uploader && this.$refs.uploader.clearFiles()
      }
    },
  },
  methods: {
    async onUploadHandler (data) {
      data = data.map(file => file.uuid)

      if (!data || !data.length) {
        this.formData.fileUuids = null
        return
      }

      this.formData.fileUuids = data
    },
    async cancelOrder (data) {
      this.$refs.confirmModal.close()
      try {
        this.isLoading = true
        await api.orderProcess.cancelOrderEvent({ data })
        this.isLoading = false
        this.$emit('on-submited')
      } catch (e) {
        this.isLoading = false
        this.$notification({
          type: 'system_notification_error',
          message: 'Невозможно отменить заказ'
        })
      }
    },
    async onSubmitHandler () {
      this.$refs.confirmModal.open()

    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-request-execution {
    .row {
      margin-top: 20px!important;
      margin-bottom: 20px!important;
    }
    .title {
      margin-top: 20px;
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base!important, 0.4px);
    }

    &::v-deep {
      .ob-radio-container {
        margin-top: 15px;
      }
      .ob-textarea {
        margin-top: 20px;
      }
    }
  }
</style>
